/*
 * language: C
 * filename: apid_c.c
 */
#include <stdio.h>
#include "libTM.h"    


int 
main(int argc, char **argv)
{
    int             size, ccsds_apid[1], ccsds_grouping_flg[1];
    char            buf[50];
    uint32_t        stream_id;
    int             ret;


    if (argc != 4)
    {
        fprintf(stderr, "usage: %s Mission Spacecraft Instrument\n", argv[0]);
        return 0;
    }
    
    TM_Select_Domain(&stream_id, argv[1], argv[2], argv[3], "packet");
    TM_Select_Stream(stream_id, "realtime");

    /* infinite loop */
    while ((ret = TM_Find_Event(stream_id)) == 0)
    {
        ret = TM_Get_Item_I4(stream_id, "CCSDS_APID", ccsds_apid, 1, &size);
        if (ret != 0)
        {
            printf("error: %d\n", ret);
            return 0;
        }
        ret = TM_Get_Item_I4(stream_id, "CCSDS_GROUPING_FLG", ccsds_grouping_flg, 1, &size);
        if (ret != 0)
        {
            printf("error: %d\n", ret);
            return 0;
        }
        ret = TM_Get_Item_Char(stream_id, "CCSDS_GROUPING_FLG", buf, 50, &size);
        if (ret != 0)
        {
            printf("error: %d\n", ret);
            return 0;
        }
        printf("APID: 0x%04x - 0x%02x(%s)\n", ccsds_apid[0], ccsds_grouping_flg[0], buf);
    }

    return 0;
}
